//
//  NSBezierPath-NisusAdditions.h
//  Toolbox
//
//  Created by Martin Wierschin on Fri Apr 16 2004.
//  Copyright (c) 2004 Nisus Software, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface NSBezierPath (NisusAdditions)

+ (NSPoint) rotatePoint:(NSPoint)pt byDegrees:(CGFloat)degrees origin:(NSPoint)origin ;
+ (NSBezierPath*) bezierPathBySubtractingRect:(NSRect)subtractRect fromRect:(NSRect)wholeRect ;

// testing intersections
+ (NSPoint) intersectionPointForLineWithEndpoints:(NSPoint)p1 :(NSPoint)p2 otherLineEndpoints:(NSPoint)p3 :(NSPoint)p4 ;
- (BOOL) getBoundsNisus:(NSRect*)overlapPtr fromX:(CGFloat)x1 toX:(CGFloat)x2 usingVerticalScanCount:(NSUInteger)scanCount ;
- (BOOL) getBoundsNisus:(NSRect*)overlapPtr fromY:(CGFloat)y1 toY:(CGFloat)y2 usingHorizontalScanCount:(NSUInteger)scanCount ;

// gradient drawing
+ (void) fillRect:(NSRect)rect withVerticalGradientFromColor:(NSColor*)srcC to:(NSColor*)destC ;
+ (void) fillRect:(NSRect)rect withHorizontalGradientFromColor:(NSColor*)srcC to:(NSColor*)destC ;

- (void) fillAxialGradientFrom:(NSPoint)srcPt to:(NSPoint)destPt fromColor:(NSColor*)srcC to:(NSColor*)destC isExtendStart:(BOOL)srcIsExt end:(BOOL)destIsExt ;
- (void) fillVerticalGradientFromColor:(NSColor*)srcC to:(NSColor*)destC ;
- (void) fillHorizontalGradientFromColor:(NSColor*)srcC to:(NSColor*)destC ;

// some traditional GUI shapes
+ (NSBezierPath*) bezierPathWithRoundedPillInRect:(NSRect)rect ;
+ (void) getRoundedPillBezierPathLeftCap:(NSBezierPath**)leftPtr rightCap:(NSBezierPath**)rightPtr forRect:(NSRect)rect ;

+ (NSBezierPath*) bezierPathWithRoundRectInRect:(NSRect)rect radius:(CGFloat)radius ;
+ (NSBezierPath*) bezierPathWithDisclosureTriangleAtPoint:(NSPoint)origin height:(CGFloat)h isOpen:(BOOL)isOpen ;
+ (NSBezierPath*) bezierPathWithNavigationTriangleInRect:(NSRect)rect isMoveNext:(BOOL)isNext ;

+ (NSBezierPath*) bezierPathEnclosingLineFragmentRectArray:(NSRectArray)rects count:(NSUInteger)count roundedRectRadius:(CGFloat)radius inset:(CGSize)inset ;

@end
