/* 
================================================================================
File:    NSCharacterSet-NisusAdditions.h
Project: NisusToolboxAuthor:  cjolley
Date:    Fri Jul 19 2002 
================================================================================
Copyright (c) 2002, Nisus Software, Inc.

*/

#import <Cocoa/Cocoa.h>




@interface NSCharacterSet (NisusAdditions)

+ (NSCharacterSet*) gremlinCharacterSet ;
+ (NSCharacterSet*) privateUseAreaCharacterSet ;
+ (NSCharacterSet*) hexCodeCharacterSet ;

+ (NSCharacterSet*) strictDecimalDigitCharacterSet ;
+ (NSCharacterSet*) strictNonDecimalDigitCharacterSet ;
+ (NSCharacterSet*) nonPrintingCharacterSet ;

+ (NSCharacterSet*) paragraphBreakCharacterSet ; // includes all chars used to delim paragraphs
+ (NSCharacterSet*) lineBreakCharacterSet ; // includes chars used to determine a line break during layout
+ (NSCharacterSet*) spaceCharacterSet ; // only spaces like ideograph space, half-width space, etc. No other whitespace.
+ (NSCharacterSet*) allWhitespaceCharacterSet ;
+ (NSCharacterSet*) nonWhitespaceCharacterSet ;
+ (NSCharacterSet*) textContainerBreakCharacterSet ;

+ (NSCharacterSet*) directionalityCharacterSet ; // characters that control the direction of text

+ (NSCharacterSet*) openQuoteCharacterSet ; // includes straight quotes
+ (NSCharacterSet*) closeQuoteCharacterSet ; // includes straight quotes
+ (NSCharacterSet*) quoteCharacterSet ;
+ (NSCharacterSet*) sentenceTerminalCharacterSet ;
+ (NSCharacterSet*) fullStopCharacterSet ;

+ (NSCharacterSet*) groupingPunctuationCharacterSet ; // all characters that are normally balanced as open/close marks in text, eg: () <> "" []
+ (NSCharacterSet*) openingGroupingPunctuationCharacterSet ;

// generating new sets
- (NSCharacterSet*) copyImmutable ;

- (NSCharacterSet*) characterSetByAddingCharactersInRange:(NSRange)charRng ;
- (NSCharacterSet*) characterSetByAddingCharactersInString:(NSString*)str ;

@end


@interface NSMutableCharacterSet (NisusAdditions)
- (void) addCharacter:(unichar)ch ;
@end

