//
//  NSData-NisusAdditions.h
//  NisusToolbox
//
//  Created by Charles Jolley on Thu Jun 26 2003.
//  Copyright (c) 2003 Nisus Software, Inc.. All rights reserved.
//

#import <Cocoa/Cocoa.h>



@interface NSData (NisusAdditions)

- (NSData*) dataByRepeatingNumberOfTimesNisus:(NSUInteger)repeatCount ;

+ (NSData*) dataReadingFromStartOfFileAtURL:(NSURL*)fileURL maximumLength:(unsigned long long)maxLen error:(NSError**)errorPtr ;
+ (NSData*) dataReadingFromEndOfFileAtURL:(NSURL*)fileURL maximumLength:(unsigned long long)maxLen error:(NSError**)errorPtr ;

- (NSRange) rangeOfData:(NSData*)find ;
- (NSRange) rangeOfData:(NSData*)find range:(NSRange)subRng ;
- (NSRange) rangeOfBytes:(const void*)bytes length:(NSUInteger)byteCount ;
- (NSRange) rangeOfBytes:(const void*)bytes length:(NSUInteger)byteCount range:(NSRange)subRng ;
- (NSRange) rangeOfCStringNisus:(const char*)cstr options:(NSDataSearchOptions)ops range:(NSRange)searchRange ;
- (NSRange) rangeOfString:(NSString*)str usingEncoding:(NSStringEncoding)strEnc range:(NSRange)subRange ;

- (NSUInteger) countInequalBytes:(NSData*)other indexOfFirstEqual:(NSUInteger *)equalIdxPtr ;
- (NSUInteger) countInequalInts:(NSData*)other indexOfFirstEqual:(NSUInteger *)equalIdxPtr ;

// base64 strings
+ (id) dataWithBase64String:(NSString*)base64String ;
- (id) initWithBase64String:(NSString *)base64String ;
- (NSData*) base64DataWithLineLength:(NSUInteger)lineLen ;
- (NSString*) base64String;

// hex strings
+ (id) dataWithHexStringNisus:(NSString *)hexString;
- (NSString *)lowercaseHexString; /* has a leading 0x (sigh) */
- (NSString *)unadornedLowercaseHexString;  /* no 0x */
- (void) appendLowercaseHexASCIIToData:(NSMutableData*)mdata ;

// compress/decompress
- (NSData*) dataByCompressingZlib ;
- (NSData*) dataByDecompressingZlib ;
- (NSData*) dataByCompressingGZip ;
- (NSData*) dataByDecompressingGZip ;
- (NSData*) dataByDecompressingGZipWithMaximumLength:(NSUInteger)maxLen ;

@end
