//
//  NSDictionary-NisusAdditions.h
//  Toolbox
//
//  Created by Martin on Fri Jul 25 2003.
//  Copyright (c) 2003 Nisus Software, Inc.. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <NisusCore/NisusCollection.h>

@protocol NisusKeyProvider <NSObject, NSFastEnumeration>
- (NSUInteger) count ;
@end

@interface NSSet (NisusKeyProvider) <NisusKeyProvider>
@end

@interface NSArray (NisusKeyProvider) <NisusKeyProvider>
@end




@interface NSDictionary (NisusAdditions)

+ (instancetype) dictionaryWithObject:(id)obj setForAllNisusKeys:(id<NisusCollection>)keys ;

- (id) containsKey:(id)key usingCompareSelector:(SEL)sel ;

- (BOOL) containsKeyInSet:(NSSet*)keys ;
- (BOOL) containsKeyInDictionary:(NSDictionary*)dict ;

- (BOOL) isEqualToDictionary:(NSDictionary*)d forKeys:(NSSet*)keys ;
- (BOOL) isEqualToDictionary:(NSDictionary*)d ignoringKeys:(NSSet*)keys ;
- (BOOL) isSubdictionaryOf:(NSDictionary*)d ;

- (NSDictionary*) dictionarySettingObject:(id) o forKey: (id) k ;
- (NSDictionary*) dictionaryRemovingObjectForKey: (id) k ;
- (NSDictionary*) dictionaryRemovingObjectsForKeys:(id<NisusKeyProvider>)keys ;
- (NSDictionary*) dictionaryByAddingEntriesFromDictionary:(NSDictionary*)d ;
- (NSDictionary*) subdictionaryWithKeys:(id<NisusKeyProvider>)keys ;
- (NSDictionary*) newSubdictionaryWithKeys:(id<NisusKeyProvider>)keys ;

- (BOOL) boolForKey:(id)key ;
- (BOOL) boolForKey:(id)key defaultValue:(BOOL)def ;
- (NSInteger) intForKey:(id)key ;
- (NSInteger) intForKey:(id)key defaultValue:(NSInteger)def ;
- (float)floatForKey:(id)key ;
- (float)floatForKey:(id)key defaultValue:(CGFloat)def ;
- (double) doubleForKey:(id)key ;
- (double) doubleForKey:(id)key defaultValue:(double)def ;

@end
