//
//  NSError+NisusCore.h
//  NisusCore
//
//  Created by Martin on 2013.10.10.
//  Copyright (c) 2013 Nisus. All rights reserved.
//

#import <Foundation/Foundation.h>

extern NSString* NisusCoreErrorDomain;

typedef enum {
	NisusCoreErrorCode_None = 0,
	NisusCoreErrorCode_InvalidData = 1,
	NisusCoreErrorCode_FailedCaptureBookmark = 2,
	NisusCoreErrorCode_ExceptionOccurred = 3,
	NisusCoreErrorCode_InvalidPlist = 4,
	NisusCoreErrorCode_TaskFailed = 5,
	
	NisusCoreErrorCode_Unknown = 999,
} NisusCoreErrorCode;




@interface NSError (NisusCore)

- (NSString*) descriptionForUserNisus ;

+ (NSError*) errorWithDomain:(NSString*)domain code:(NSInteger)code localizedDescription:(NSString*)desc ;
+ (NSError*) errorWithDomain:(NSString*)domain code:(NSInteger)code exception:(NSException*)excep ;
+ (NSError*) errorWithException:(NSException*)excep ;

+ (NSError*) unknownErrorNisus ;
+ (NSError*) userCancellationErrorNisus ;

- (BOOL) isUserCancellationErrorNisus ;
- (BOOL) isErrorDomainNisus:(NSString*)domain code:(NSInteger)code ;
- (BOOL) isErrorNoSuchFileNisus ;

@end

