//
//  NSEvent-NisusAdditions.h
//  WriterMerged
//
//  Created by Martin on 2006.08.03.
//  Copyright 2006 Nisus Software, Inc. All rights reserved.
//

#import <Cocoa/Cocoa.h>




@interface NSEvent (NisusAdditions)

+ (NSTimeInterval) currentEventTimestamp ;
+ (NSUInteger) currentModifierFlags ;
+ (BOOL) isCommandKeyDown ;
+ (BOOL) isShiftKeyDown ;
+ (BOOL) isOptionKeyDown ;
+ (BOOL) isMouseCurrentlyDown ;

+ (NSEvent*) mouseEventNisusWithType:(NSEventType)type location:(NSPoint)viewPt inView:(NSView*)view modifierFlags:(NSEventModifierFlags)flags clickCount:(NSInteger)clickCount pressure:(float)pressure ;

- (BOOL) isEnterKeyEvent ;
- (BOOL) isReturnKeyEvent ;
- (BOOL) isArrowKeyEvent ;
- (unichar) firstCharacterForKeyEvent ;

- (NSPoint) locationConvertedToWindow:(NSWindow*)targetWin ;
- (NSPoint) locationConvertedToView:(NSView*)view ;
- (NSEvent*) eventConvertedForUseInWindow:(NSWindow*)targetWin ;

@end
