//
//  NSMenu+NisusCore.h
//  NisusCore
//
//  Created by Martin on 2013.10.10.
//  Copyright (c) 2013 Nisus. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSMenu (NisusCore)

- (void) addItems:(NSArray*)items ;
- (void) insertItems:(NSArray*)items atIndex:(NSUInteger)insertIdx ;
- (NSMenuItem*) addItemWithTitle:(NSString*)title target:(id)target action:(SEL)action ;
- (NSMenuItem*) addItemWithTitle:(NSString*)title target:(id)target action:(SEL)action tag:(NSInteger)tag ;
- (NSMenuItem*) addItemWithTitle:(NSString*)title target:(id)target action:(SEL)action representedObject:(id)repObj ;
- (NSMenuItem*) addItemWithSubmenuNisus:(NSMenu*)submenu ;

- (void) removeItemsInRange:(NSRange)itemRng ;
- (NSRange) rangeOfItemsBeforeFirstSeparatorInRange:(NSRange)searchRange forwards:(BOOL)isSearchForward ;
- (void) removeSuperfluousSeparatorItems ;

- (NSMenuItem*) parentMenuItem ;
- (BOOL) removeFromSupermenu ;

// matching items
- (NSInteger) indexOfItemWithTagIgnoringSeparatorsNisus:(NSInteger)tag ;
- (NSMenuItem*) itemWithAction:(SEL)action ;
- (NSUInteger) indexOfItemWithActionNisus:(SEL)action ;
- (NSMenuItem*) itemWithActionNestedSearch:(SEL)action getParentMenu:(NSMenu**)menuPtr getItemIndex:(NSUInteger*)itemIndexPtr ;

- (BOOL) visitItemsRecursivelyNisusUsing:(void(^)(NSMenuItem* item, NSUInteger itemIndex, BOOL* stop))visitor ;
- (NSMenuItem*) itemMatchedRecursivelyNisusAndGetIndex:(NSUInteger*)foundItemIndexPtr using:(BOOL(^)(NSMenuItem* item))matcher ;

@end
