//
//  NSMenuItem+NisusCore.h
//  NisusCore
//
//  Created by Martin on 2013.10.10.
//  Copyright (c) 2013 Nisus. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSMenuItem (NisusCore)

+ (NSMenuItem*) itemWithTitle:(NSString*)title target:(id)target action:(SEL)action ;
+ (NSMenuItem*) itemWithTitle:(NSString*)title target:(id)target action:(SEL)action tag:(NSInteger)tag ;
+ (NSMenuItem*) itemWithTitle:(NSString*)title target:(id)target action:(SEL)action representedObject:(id)repObj ;

+ (NSMenuItem*) itemWithoutActionDisplayingCaptionToUserNisus:(NSString*)title ;
+ (NSMenuItem*) itemWithSubmenuNisus:(NSMenu*)submenu ;

+ (void) sortMenuItemsByTitle:(NSMutableArray*)items ;

- (void) setStateFromBool:(BOOL)isChecked ;
- (void) setImageUsingNormalSizeNisus:(NSImage*)icon ;

- (void) dispatchActionAsIfChosenByUser ;
- (BOOL) removeFromMenu ;

@end

