//
//  NSSet-NisusAdditions.h
//  WriterMerged
//
//  Created by Martin on 2007.05.21.
//  Copyright 2007 Nisus Software, Inc. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSSet (NisusAdditions)

+ (NSSet*) setByAddingObjectNisus:(id)obj toSet:(NSSet*)set ;
- (NSSet*) setByRemovingObjectNisus:(id)obj ;

- (NSSet*) setByAddingObjectsInSet:(NSSet*)set ;
- (NSSet*) setByRemovingObjectsInSet:(NSSet*)set ;
- (NSString*) componentsJoinedByString:(NSString*)join ;

@end


@interface NSMutableSet (NisusAdditions)

- (void) addObjectsInSet:(NSSet*)addObjs ;
- (void) removeObjectsInSet:(NSSet*)remObjs ;
- (void) removeObjectsInArray:(NSArray*)remObjs ;

@end




// Methods for sorting a counted set, which I've never needed in production code yet, but has been nice for debugging 
#if NISUS_DEBUG
@interface NSCountedSet (NisusAdditions)

- (NSArray*) objectsSortedByCountAscendingNisus:(BOOL)isAsc ;
- (void) enumerateObjectsSortedByCountAscendingNisus:(BOOL)isAsc using:(void(^)(id object, NSUInteger count, BOOL* stop))visitor ;

@end
#endif // NISUS_DEBUG

