//
//  NSString+NisusCoreUnicode.h
//  NisusCore
//
//  Created by Martin on 2013.10.11.
//  Copyright (c) 2013 Nisus. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <NisusCore/NisusUnicodeUtil.h>



@interface NSString (NisusCoreUnicode)

// Strings with characters outside the range of unichar (eg: code points equal to or above U+10000)
+ (NSString*) stringWithCodepoint:(NisusUnicodePoint)code ;
+ (NSString*) stringWithCodepoints:(NisusUnicodePoint*)codes count:(NSUInteger)count ;

- (NSString*) initWithCodepoints:(NisusUnicodePoint*)codes count:(NSUInteger)count ;
- (NSUInteger) getCodepoints:(NisusUnicodePoint*)buffer range:(NSRange)rng ;
- (NSUInteger) countCodepointsInRange:(NSRange)rng ;

- (NSRange) rangeOfCodepointAtIndex:(NSUInteger)charIdx ;
- (NisusUnicodePoint) codepointAtIndex:(NSUInteger)charIdx effectiveRange:(NSRange*)rngPtr ;
- (NisusUnicodePoint) hexCodepointValueAtIndex:(NSUInteger)start effectiveRange:(NSRange*)effRngPtr ;

@end
