//
//  NSTableView-NisusAdditions.h
//  Toolbox
//
//  Created by Martin Wierschin on Wed Apr 21 2004.
//  Copyright (c) 2004 Nisus Software, Inc. All rights reserved.

// Normally NSTableView does absolutely nothing if you disable it. Added a method
// that allows disabling a table view to some degree. You will still need to refuse
// selection changes via the table delegate.

#import <Foundation/Foundation.h>


@interface NSTableView (NisusCore)

- (void) setTableViewEnabled:(BOOL)isEn ;

- (void) selectSingleRow:(NSUInteger)rowIdx scroll:(BOOL)isScroll ;

// chaning columns en masse
- (void) addTableColumns:(NSArray*)cols ;
- (void) removeTableColumns:(NSArray*)cols ;
- (void) setTableColumns:(NSArray*)cols ;

// displayed content as string
- (NSString*) selectedRowContentAsPlainText ;

@end

