//
//  NSURL-NisusAdditions.h
//  WriterMerged
//
//  Created by Martin on 2009.12.09.
//  Copyright 2009 Nisus. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSURL (NisusAdditions)

+ (NSString*) stringByAddingMostPercentEscapesToString:(NSString*)plainStr ;

- (NSString*) filePathForUserDisplay ;
- (NSString*) filePathForDebugDisplay ;

// some file convenience methods
- (NSURL*) URLByResolvingSymlinkOrAliasFile ;
- (NSURL*) URLByResolvingToRealFileOutsideSandbox ;

- (BOOL) boolResourceValueForKey:(NSString*)key ;
- (id) resourceValueForKey:(NSString*)key defaultValueNisus:(id)defaultValue ;
- (BOOL) isFileDirectoryNisus ;

// comparing file paths
- (BOOL) hasFilePathExtensionNisus:(NSString*)testExt ;
- (BOOL) isFileEquivalentPathAsURL:(NSURL*)url ;
- (BOOL) isFileEqualNodeAsURL:(NSURL*)other ;
- (BOOL) isFileInFolderAtURL:(NSURL*)folderURL ;
- (BOOL) isFileInDescendentOfFolderAtURL:(NSURL*)folderURL ;
- (NSString*) fileSubpathDescendingFromEnclosingFolderURL:(NSURL*)folderURL ;

// converting to and from paths/strings
- (instancetype) initFileURLWithNisusPath:(NSString*)path ;
+ (NSURL*) fileURLWithNisusPath:(NSString*)path ;
+ (NSURL*) URLWithNisusValidatedString:(NSString*)text ;

- (NSString*) nisusFilePath ;
- (NSString*) nisusFilePathRelativeToBaseURL:(NSURL*)url ;
- (NSString*) nisusStringify ;
- (NSString*) nisusStringifyWithoutPercentEncoding ;

// URLs with query strings
+ (NSURL*) URLWithNisusUnencodedString:(NSString*)rawString queryStringArguments:(NSDictionary*)argMap ;
- (NSDictionary*) nisusQueryStringDictionary ;

@end
