//
//  NSUserDefaults-NisusAdditions.h
//  WriterMerged
//
//  Created by Martin on 2008.11.21.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <NisusCore/NisusUtil.h>


@interface NSUserDefaults (NisusAdditions)

// Basic type accessors that allow control of default return value.
- (id) objectForKey:(id)key defaultValue:(id)def ;
- (BOOL) boolForKey:(id)key defaultValue:(BOOL)def ;
- (NSInteger) integerForKey:(id)key defaultValue:(NSInteger)def ;
- (CGFloat) floatForKey:(id)key defaultValue:(CGFloat)def ;

// storing font information
- (NSFont*) fontForKey:(NSString*)key ;
- (NSFont*) fontForKey:(NSString*)key defaultValue:(NSFont*)font ;
- (void) setFont:(NSFont*)font forKey:(NSString*)key ;

@end


#define NSUserDefaults_GET_ENUM( defaultsKey, enumType, enumDefaultValue )	\
	(NISUS_CAST_ENUM(enumType, [[NSUserDefaults standardUserDefaults] integerForKey:defaultsKey defaultValue:enumDefaultValue]))






