//
//  NSView-NisusAdditions.h
//  Toolbox
//
//  Created by Martin Wierschin on Tue May 25 2004.
//  Copyright (c) 2004 Nisus Software, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface NSResponder (NisusCore)

// routes an event to the proper action method
- (void) dispatchEventToStandardSelector:(NSEvent*)ev ;
- (BOOL) dispatchScrollSelector:(SEL)sel withSender:(id)sender ;

@end




@interface NSView (NisusCore)

#if NISUS_DEBUG
- (NSString*) debugSubviewsNisus ;
- (NSString*) debugSuperviewsNisus ;
#endif

- (id) adjacentLeftSiblingViewOfKind:(Class)viewClass ;
- (id) adjacentRightSiblingViewOfKind:(Class)viewClass ;
- (id) adjacentTopSiblingViewOfKind:(Class)viewClass ;
- (id) adjacentBottomSiblingViewOfKind:(Class)viewClass ;

- (NSView*) subviewContainingEvent:(NSEvent*)ev ;
- (NSView*) dispatchEventToSubview:(NSEvent*)ev ;
- (void) simulateMouseClickForEvent:(NSEvent*)ev ;

- (NSImage*) imageWithCachedDisplayInRectNisus:(NSRect)rect ;

- (BOOL) scrollRectToVisibleNisus:(NSRect)rect verticalFractionDownward:(CGFloat)fractionDown ;

// frames
- (BOOL) isFrameSameAsRect:(NSRect)rect ;

- (NSPoint) convertPointFromScreen:(NSPoint)screenPt ;
- (NSPoint) convertPointToScreen:(NSPoint)viewPt ;

// replaces all subviews of the receiver with those in given view
- (void) replaceContentsWithContentsOfView:(NSView*)source ;

@end





