//
//  NSWindow+NisusCore.h
//  NisusCore
//
//  Created by Martin on 2013.10.11.
//  Copyright (c) 2013 Nisus. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define NTWindowCollectionBehaviorFullScreenPrimary (1 << 7)
#define NTFullScreenWindowMask (1 << 14)



@interface NSWindow (NisusCore)

- (void) commitEditingNisus ;

- (void) enterModalMouseDownLoopWithPeriodicEventDelay:(NSTimeInterval)delay eventHandler:(void(^)(NSEvent* event, BOOL* stop))handler ;
- (void) enterModalMouseDownLoopAllowingCancel:(BOOL)isAllowCancel periodicEventDelay:(NSTimeInterval)delay eventHandler:(void(^)(NSEvent* event, BOOL isCancelled, BOOL* stop))handler ;

- (NSRect) validWindowFrameForProposedFrameNisus:(NSRect)propFrame ;

// document
- (id) nisusDocument ;
- (NSWindow*) nisusDocumentWindow ;

- (BOOL) isVisibleDocumentWindow ;
- (BOOL) isVisibleWindowWithDocumentOfClass:(Class)docClass ;

// full screen
+ (BOOL) isAppleFullScreenModeActive ;
- (void) enableAppleFullScreenCollectionBehavior ;

@end

