//
//  NisusAssertionInfo.h
//  NisusCore
//
//  Created by Martin on 2013.08.29.
//  Copyright (c) 2013 Nisus. All rights reserved.
//
// Holds all the information related to a single failed assertion.

#import <Foundation/Foundation.h>
#import <NisusCore/NisusAssertions.h>
#import <NisusCore/NSDate+NisusCore.h>




@interface NisusAssertionInfo : NSObject {
	NisusAssertType _assertionType;
	NSUInteger _sequenceNumber;
	
	NSString* _failedExpression;
	NSString* _userFriendlyMessage;
	NSString* _fileName;
	NSUInteger _fileLineNumber;
	
	NisusTimeMark _timeMark;
	NSArray* _stackTrace;
}

- (NSString*) shortDescription ;

// set on creation
@property (readonly) NSUInteger sequenceNumber;
@property (readonly) NisusTimeMark timeMark;		// the time the assert occurred

// properties set by client
@property NisusAssertType assertionType ;

@property (copy) NSString* failedExpression ;
@property (copy) NSString* userFriendlyMessage ;
@property (copy) NSString* operationTitle ;

@property (copy) NSString* fileName ;
@property NSUInteger fileLineNumber ;

// stack, which is set later, after we know the assertion will be logged/reported
@property (copy) NSArray* stackTrace ;
@property NSUInteger repeatCount ;

// comparison
- (NSString*) equalityKey ;
- (BOOL) isSameFailedAssertion:(NisusAssertionInfo*)other ;

@end


