//
//  NisusAvailability.h
//  NisusCore
//
//  Created by Martin on 2014.08.21.
//  Copyright (c) 2014 Nisus. All rights reserved.
//

#ifndef NisusCore_NisusAvailability_h
#define NisusCore_NisusAvailability_h

#if defined(NISUS_SDK_WARNINGS)
#import <Availability.h>


#define __AVAILABILITY_TOO_NEW __attribute__((deprecated("API is too new"))) __attribute__((weak_import))


#if defined(__MAC_OS_X_VERSION_MIN_REQUIRED)
	#ifndef __MAC_OS_X_VERSION_SOFT_MAX_REQUIRED
		#define __MAC_OS_X_VERSION_SOFT_MAX_REQUIRED __MAC_OS_X_VERSION_MIN_REQUIRED
	#endif
	#if __MAC_OS_X_VERSION_SOFT_MAX_REQUIRED < __MAC_OS_X_VERSION_MIN_REQUIRED
		#error You cannot ask for a soft max version which is less than the deployment target
	#endif

	#if __MAC_OS_X_VERSION_SOFT_MAX_REQUIRED < __MAC_10_6
		#undef __AVAILABILITY_INTERNAL__MAC_10_6
		#define __AVAILABILITY_INTERNAL__MAC_10_6 __AVAILABILITY_TOO_NEW
	#endif
	#if __MAC_OS_X_VERSION_SOFT_MAX_REQUIRED < __MAC_10_7
		#undef __AVAILABILITY_INTERNAL__MAC_10_7
		#define __AVAILABILITY_INTERNAL__MAC_10_7 __AVAILABILITY_TOO_NEW
	#endif
	#if __MAC_OS_X_VERSION_SOFT_MAX_REQUIRED < __MAC_10_8
		#undef __AVAILABILITY_INTERNAL__MAC_10_8
		#define __AVAILABILITY_INTERNAL__MAC_10_8 __AVAILABILITY_TOO_NEW
	#endif
	#if __MAC_OS_X_VERSION_SOFT_MAX_REQUIRED < __MAC_10_9
		#undef __AVAILABILITY_INTERNAL__MAC_10_9
		#define __AVAILABILITY_INTERNAL__MAC_10_9 __AVAILABILITY_TOO_NEW
	#endif
#endif // end of #if defined(__MAC_OS_X_VERSION_MIN_REQUIRED)




#if (defined(__MAC_10_9) &&  __MAC_OS_X_VERSION_MAX_ALLOWED >= __MAC_10_9) 
	#include <CoreFoundation/CFAvailability.h>

	#undef CF_AVAILABLE
	#define CF_AVAILABLE(_mac, _ios) __OSX_AVAILABLE_STARTING(__MAC_##_mac, __IPHONE_##_ios)

	#undef CF_AVAILABLE_MAC
	#define CF_AVAILABLE_MAC(_mac) __OSX_AVAILABLE_STARTING(__MAC_##_mac, __IPHONE_NA)

	#undef CF_AVAILABLE_IOS
	#define CF_AVAILABLE_IOS(_ios) __OSX_AVAILABLE_STARTING(__MAC_NA, __IPHONE_##_ios)
#endif


#endif // defined(NISUS_SDK_WARNINGS)
#endif // NisusCore_NisusAvailability_h
