//
//  NisusCollection.h
//  NisusCore
//
//  Created by Martin on 2015.07.20.
//  Copyright (c) 2015 Nisus. All rights reserved.
//
// A protocol that Cocoa collections already implement, but we explicitly codify for APIs.

#import <Foundation/Foundation.h>

@protocol NisusCollection <NSFastEnumeration>
- (NSUInteger) count;
- (NSArray*) allObjectsNisus ;
@end



// Cocoa class conformance.
@interface NSArray (NisusCollection) <NisusCollection>
@end

@interface NSSet (NisusCollection) <NisusCollection>
@end

// We consider a dictionary to be a collection of keys, not their mapped values.
@interface NSDictionary (NisusCollection) <NisusCollection>
@end
