//
//  NisusDirectArray.h
//  NisusCore
//
//  Created by Martin on 2017.07.17.
//  Copyright © 2017 Nisus. All rights reserved.
//
//	This array is like NSArray in that it stores (and retains) Objective-C objects,
//	but is designed to squeeze out some extra performance for some specialty use cases (eg: Nisus attribute caches)
//	You need to know how many objects you'll have (the capacity) over the lifetime of the array. It does NOT realloc.

#import <Foundation/Foundation.h>


@interface NisusDirectArray : NSMutableArray {
	NSUInteger _count;
	NSUInteger _capacity;
	id* _buffer;
}

- (instancetype) initWithCapacity:(NSUInteger)capacity ;

- (BOOL) isEqualToNisusDirectArray:(NisusDirectArray*)other ;

- (NSUInteger) count ;
- (id) objectAtIndex:(NSUInteger)idx ;
- (const id*) bufferForObjectRangeNisus:(NSRange)range getBoundsPointer:(const id**)outOfBoundsPtr ;

- (void) addObject:(id)obj ;
- (void) addObjectsFromArray:(NSArray*)array ;

- (void) sortLiteralStringsInRange:(NSRange)objectRange ; // exact string comp using NSLiteralSearch

@end

