//
//  NisusFileWatcher.h
//  WriterMerged
//
//  Created by Martin on 2007.03.15.
//  Copyright 2007 Nisus Software, Inc. All rights reserved.

// This is a wrapper around UKKQueue in case we ever want/have to swap it out.

#import <Cocoa/Cocoa.h>
@class UKKQueue;
@class NisusFileWatcher;

// The kinds of actions the delegate can watch for and be notified about.
typedef enum {
	NisusFileWatcherAction_None				= 0,
	NisusFileWatcherAction_Rename				= 1 << 0,
	NisusFileWatcherAction_Write				= 1 << 1,
	NisusFileWatcherAction_Delete				= 1 << 2,
	NisusFileWatcherAction_AttributeChange		= 1 << 3,
	NisusFileWatcherAction_SizeIncrease		= 1 << 4,
	NisusFileWatcherAction_LinkCountChange		= 1 << 5,
	NisusFileWatcherAction_AccessRevocation	= 1 << 6,
} NisusFileWatcherAction;
#define NisusFileWatcherActions_ALL (0xFFFFFFFF)


@protocol NisusFileWatcherDelegate
- (void) fileWatcher:(NisusFileWatcher*)fw notedAction:(NisusFileWatcherAction)action forFileAtPath:(NSString*)path ;
@end





@interface NisusFileWatcher : NSObject {
	UKKQueue* _queue;
	NSMutableArray* _openFiles;
}

+ (NisusFileWatcher*) instance ;

- (id) addFileAtPath:(NSString*)path actions:(NisusFileWatcherAction)actions delegate:(id<NisusFileWatcherDelegate>)del ;
- (void) removeFileWithToken:(id)token ;

@end




