//
//  NisusIvars.h
//  WriterMerged
//
//  Created by Martin on 2011.03.04.
//  Copyright 2011 Nisus. All rights reserved.
//
// These macros are to help with ivars following manually managed references (MMR).
// You use them to implement setters, or to clear ivars during dealloc.



#define NISUS_IVAR_SET( ivar, expr )			\
{												\
	id nisIvarCurVal = ivar;					\
	id nisIvarNewVal = (expr);					\
	if( nisIvarCurVal != nisIvarNewVal ) {		\
		nisIvarNewVal = [nisIvarNewVal retain];	\
		ivar = nisIvarNewVal;					\
		[nisIvarCurVal release];				\
	}											\
}

#define NISUS_IVAR_COPY( ivar, expr )				\
{													\
	id nisIvarCurVal = ivar;						\
	__typeof__(ivar) nisIvarNewVal = (expr);		\
	if( nisIvarCurVal != nisIvarNewVal ) {			\
		nisIvarNewVal = (id)[nisIvarNewVal copy];	\
		ivar = nisIvarNewVal;						\
		[nisIvarCurVal release];					\
	}												\
}

#define NISUS_IVAR_CLEAR( ivar )	\
{									\
	id nisIvarCurVal = ivar;		\
	if( nil != nisIvarCurVal ) {	\
		ivar = nil;					\
		[nisIvarCurVal release];	\
	}								\
}

#define NISUS_IVAR_INVALIDATE( ivar )		\
{											\
	__typeof__(ivar) nisIvarCurVal = ivar;	\
	if( nil != nisIvarCurVal ) {			\
		ivar = nil;							\
		[nisIvarCurVal invalidate];			\
		[nisIvarCurVal release];			\
	}										\
}

