//
//  NisusLocalization.h
//  NisusCore
//
//  Created by Martin on 2013.10.10.
//  Copyright (c) 2013 Nisus. All rights reserved.
//
// Macros/functions that help with localization.

#import <Foundation/Foundation.h>



NSString* NisusLocalizeInBundle( NSString* str, NSBundle* bundle );
NSString* NisusLocalizeUsingClass( NSString* str, Class classObject );

// macros that expect "self" to be defined, so that the appropriate main bundle can be determined
#define NisusLocalize(str)								(NisusLocalizeUsingClass( (str), [self class] ))
#define NisusLocalizeFormat( formatStr, args... )		[NSString stringWithFormat:NisusLocalize(formatStr), ## args]



// Use these if localization is not necessarily expected.
// Instead of returning the original string, these return nil on failure, and do not log a warning.
NSString* NisusLocalizeExpectFailInBundle( NSString* str, NSBundle* bundle );
NSString* NisusLocalizeExpectFailUsingClass( NSString* str, Class classObject );

#define NisusLocalizeExpectFail(str)	(NisusLocalizeExpectFailUsingClass( (str), [self class] ))


