//
//  NisusLogging.h
//  NisusCore
//
//  Created by Martin Wierschin on 2013.10.04.
//  Copyright (c) 2013 Nisus. All rights reserved.
//

#import <NisusCore/NisusDefines.h>
#import <NisusCore/NSDate+NisusCore.h>




// Build-style specific Logging
#if NISUS_DEBUG
	#define NisusDebugLog(str , args...) NSLog(str , ## args)
#else
	#define NisusDebugLog(str , args...) 
#endif

#if NISUS_DEV_BUILD
	#define NisusDevLog(str , args...) NSLog(str , ## args)
#else
	#define NisusDevLog(str , args...) 
#endif


// Flood control. Use the defined MACRO like an IF statement, wrapping the logging block in curly braces, eg:
//
//	NisusLog_FLOOD_CONTROLLED {
//		NisusDevLog( @"some logging goes here" );
//	}

#define NisusLog_FLOOD_CONTROLLED											\
	static NisusLogFloodControlData nisusLogFloodData = {0};				\
	if( _NisusLog_ShouldLogWithFloodControlData(&nisusLogFloodData) )

typedef struct {
	NisusTimeMark lastLogTime;
	NisusTimeMark disableUntilTime;
	UInt32 floodCount;
} NisusLogFloodControlData;

extern BOOL _NisusLog_ShouldLogWithFloodControlData( NisusLogFloodControlData* dataPtr );


	   



