//
//  NisusObjectPool.h
//  NisusCore
//
//  Created by Martin on 2013.10.15.
//  Copyright (c) 2013 Nisus. All rights reserved.
//
// Helper that pools object instances that need to be frequently reused.
// Pooling/depooling is thread-safe.
//
// WARNING: objects that are pooled must be designed for reused, eg: depooling cannot ensure that ivars are nil.

#import <Foundation/Foundation.h>


@interface NisusObjectPool : NSObject {
	id* _objects;
	NSUInteger _count;
	NSUInteger _capacity;
	
	#if NISUS_DEBUG
	NSUInteger _addObjectCount;
	#endif
}

- (instancetype) initWithCapacity:(NSUInteger)capacity ;
- (instancetype) initWithOptimalCount:(NSUInteger)optCount capacity:(NSUInteger)capacity ;

- (BOOL) poolObject:(id)obj ;
- (id) newDepooledObject ;

@end

