//
//  NisusPointerKeyDictionary.h
//  InfoClick
//
//  Created by Martin Wierschin on 2013.04.15.
//  Copyright (c) 2013 Nisus. All rights reserved.
//
// Generally a replacement for NSMutableDictionary, but keys are pointers (or integers cast to pointer-size).
// Keys are NOT retained, values are retained.

#import <Foundation/Foundation.h>


@interface NisusPointerKeyDictionary : NSObject {
	CFMutableDictionaryRef _map;
}

- (NSUInteger) count ;
- (void**) newPointerVector ;

- (id) objectForPointer:(void*)key ;
- (void) setObject:(id)value forPointer:(void*)key ;
- (void) removeObjectForPointer:(void*)key ;

@end


