//
//  NisusSemaphore.h
//  NisusCore
//
//  Created by Martin on 2014.03.10.
//  Copyright (c) 2014 Nisus. All rights reserved.
//
// Object wrapper around POSIX semaphore (named system-wide inter-process flag)

#import <Foundation/Foundation.h>
#import <semaphore.h>


@interface NisusSemaphore : NSObject <NSLocking> {
	NSString* _name;
	sem_t* _sem;
	BOOL _wasCreated;
}

- (id) initWithName:(NSString*)name create:(BOOL)isCreate error:(NSError**)error ;

- (void) close ;

// semaphore semantics
- (void) wait ;
- (BOOL) tryWait ;
- (void) post ;

@end

