//
//  NisusTableView.h
//  NisusCore
//
//  Created by Martin on 2013.10.11.
//  Copyright (c) 2013 Nisus. All rights reserved.
//
// This enhanced table view does a few extra things for free. You can swap it in for a regular NSTableView.

#import <Foundation/Foundation.h>
#import <NisusCore/NSDate+NisusCore.h>


@interface NisusTableView : NSTableView {
	NSString* _autoscrollTypingString;
	NisusTimeMark _autoscrollTypingTime;
	BOOL _isAllowUserHide;
	NSUInteger _drawingRowIndex;
}

- (NSArray*) allTableColumns ;

@property (retain) NSColor* selectionHighlightColorNisus ;
- (NSUInteger) drawingRowNisus ;

// hiding columns
- (NSArray*) hiddenColumns ;
- (NSArray*) hiddenColumnIdentifiers ;
- (void) setHiddenColumnIdentifiers:(NSArray*)idents ;
- (void) setDefaultHiddenColumnIdentifiers:(NSArray*)idents ;

- (BOOL) isHideColumnWithIdentifier:(id)ident ;
- (void) setHide:(BOOL)isHide columnWithIdentifier:(id)ident ;
- (void) setAllowUserChoosesHiddenColumns:(BOOL)isUser ;

@end




// Additional delegate methods that the autoscrolling table view will call if the delegate implements them.
@protocol NisusTableViewDelegate

@optional
- (NSString*) tableViewAutoscrollingColumnIdentifier:(NSTableView*)view ; // if not implemented, table view uses first column
- (BOOL) tableViewRequestsDeleteSelectedRows:(NSTableView*)view ; // should return YES if delete was a success

- (void) tableView:(NSTableView*)view draggingEntered:(id<NSDraggingInfo>)info ;
- (void) tableView:(NSTableView*)view draggingExited:(id<NSDraggingInfo>)info ;
- (NSImage*) tableView:(NSTableView*)view requestsDragImageForRowsWithIndexes:(NSIndexSet*)rows tableColumns:(NSArray*)colObjs event:(NSEvent*)ev offset:(NSPoint*)offsetPtr ;

- (NSMenu*) tableView:(NSTableView*)view menuForEvent:(NSEvent*)ev ;

@end


