//
//  NisusURLMap.h
//  NisusCore
//
//  Created by Martin on 2014.11.25.
//  Copyright (c) 2014 Nisus. All rights reserved.
//
// Basically a limited kind of NSMutableDictionary that allows using NSURL instances as keys.
// Uniquing can be done by path (normalized) or file ID.

#import <Foundation/Foundation.h>

typedef enum {
	NisusURLMapType_Path,
	NisusURLMapType_FileID,
} NisusURLMapType;



@interface NisusURLMap : NSObject <NSCopying, NSMutableCopying> {
	NSMutableDictionary* _map;
}

- (instancetype) initWithMapType:(NisusURLMapType)type ;

- (NSUInteger) count ;
- (id) objectForURL:(NSURL*)url ;

- (void) setObject:(id)obj forURL:(NSURL*)url ;
- (void) removeObjectForURL:(NSURL*)url ;
- (void) removeAllObjects ;

@end
