//
//  NisusUTI.h
//  NisusCore
//
//  Created by Martin on 2014.07.11.
//  Copyright (c) 2014 Nisus. All rights reserved.
//

#import <Foundation/Foundation.h>

// UTIs that are defined by Nisus code
#define NISUS_CUSTOM_UTI_PREFIX @"com.nisus.uti."

// Additional UTIs, ie: supplement kUTTypeWHATEVER
extern NSString* NisusUTI_EPS;
extern NSString* NisusUTI_URLName;



@interface NisusUTI : NSObject

+ (BOOL) isKnownUTI:(NSString*)type ;

+ (NSString*) fileExtensionForUTI:(NSString*)uti ;
+ (NSString*) UTIForFileExtension:(NSString*)ext ;

+ (NSString*) pasteboardTypeForUTI:(NSString*)uti ;
+ (NSString*) UTIForPasteboardType:(NSString*)pboardType ;

+ (NSArray*) pasteboardTypesForUTIs:(NSArray*)utis cullUnknown:(BOOL)isCull ;
+ (NSArray*) UTIsForPasteboardTypes:(NSArray*)pboardTypes cullUnknown:(BOOL)isCull ;

@end


