//
//  NisusUnicodeChars.h
//  NisusCore
//
//  Created by Martin on 2013.10.11.
//  Copyright (c) 2013 Nisus. All rights reserved.
//

#import <Foundation/Foundation.h>


// control chars
#define NisusUnicode_Delete					((unichar)0x007F)

// whitespace
#define NisusUnicode_SoftReturn				((unichar)0x2028)	// unicode calls this the line separator
#define NisusUnicode_ParagraphSeparator		((unichar)0x2029)
#define NisusUnicode_NonBreakingSpace		((unichar)0x00A0)
#define NisusUnicode_NonBreakingSpaceThin	((unichar)0x202F)
#define NisusUnicode_ZeroWidthSpace			((unichar)0x200B)
#define NisusUnicode_IdeographSpace			((unichar)0x3000)

// hyphens
#define NisusUnicode_SoftHyphen				((unichar)0x00AD)
#define NisusUnicode_NonBreakingHyphen		((unichar)0x2011)
#define NisusUnicode_Break					((unichar)NSFormFeedCharacter)	// used for section and page breaks
#define NisusUnicode_NextLine				((unichar)0x0085)

// quotes
#define NisusUnicode_SingleQuote			((unichar)0x0027)
#define NisusUnicode_DoubleQuote			((unichar)0x0022)
#define NisusUnicode_OpenSingleQuote		((unichar)0x2018)	// smart single quote
#define NisusUnicode_CloseSingleQuote		((unichar)0x2019)	// smart single quote
#define NisusUnicode_OpenDoubleQuote		((unichar)0x201C)	// smart double quote
#define NisusUnicode_CloseDoubleQuote		((unichar)0x201D)	// smart double quote
#define NisusUnicode_OpenGuillemet			((unichar)0x00AB)
#define NisusUnicode_CloseGuillemet			((unichar)0x00BB)

// other
#define NisusUnicode_EnDash					((unichar)0x2013)
#define NisusUnicode_EmDash					((unichar)0x2014)
#define NisusUnicode_Bullet					((unichar)0x2022)

#define NisusUnicode_ZeroWidthNonJoiner		((unichar)0x200C)
#define NisusUnicode_ZeroWidthJoiner		((unichar)0x200D)
#define NisusUnicode_WordJoiner				((unichar)0x2060)

#define NisusUnicode_IdeographComma				((unichar)0x3001)
#define NisusUnicode_IdeographFullStop			((unichar)0x3002)
#define NisusUnicode_IdeographHalfWidthFullStop ((unichar)0xFF61)

// directionality
#define NisusUnicode_LTRMarker				((unichar)0x200E)
#define NisusUnicode_RTLMarker				((unichar)0x200F)
#define NisusUnicode_LTREmbed				((unichar)0x202A)
#define NisusUnicode_RTLEmbed				((unichar)0x202B)
#define NisusUnicode_PushDirectionLTR		((unichar)0x202D)
#define NisusUnicode_PushDirectionRTL		((unichar)0x202E)
#define NisusUnicode_PopDirection			((unichar)0x202C)

