//
//  NisusWeakKeyDictionary.h
//  WriterMerged
//
//  Created by Martin on 2007.11.28.
//  Copyright 2007 Nisus Software, Inc. All rights reserved.

// This class behaves just as NSMutableDictionary, except it does not retain its keys (eg: weak object references).

#import <Cocoa/Cocoa.h>





@interface NisusWeakKeyDictionary : NSObject {
	CFMutableDictionaryRef _map;
	#if NISUS_DEV_BUILD
	id _removingKey;
	#endif
}

- (NSUInteger) count ;
- (NSEnumerator*) keyEnumerator ;
- (NSArray*) allValues ;

- (id) objectForKey:(id)key ;
- (void) setObject:(id)value forKey:(id)key ;
- (void) removeObjectForKey:(id)key ;
- (void) removeAllObjects ;

- (BOOL) enumerateUsingBlock:(void(^)(id key, id value, BOOL* stop))visitor ;

@end



