//
//  NisusWeakObjectSet.h
//  WriterMerged
//
//  Created by Martin on 2007.12.14.
//  Copyright 2007 Nisus Software, Inc. All rights reserved.

// Alternative to NSMutableSet that does not retain the objects it collects.
// Object hashing and equality is also done by pointer value, not via -isEqual:

#import <Cocoa/Cocoa.h>


@interface NisusWeakObjectSet : NSMutableSet {
	CFMutableSetRef _set;
}

- (NSUInteger) count ;

- (BOOL) containsObject:(id)obj ;
- (void) addObject:(id)obj ;
- (void) removeObject:(id)obj ;

- (void) removeAllObjects ;

- (id) anyObject ;
- (NSArray*) allObjects ;
- (NSArray*) copyAllObjects ;

- (NSEnumerator*) objectEnumerator ;
- (void) makeObjectsPerformSelector:(SEL)sel ;
- (void) makeObjectsPerformSelector:(SEL)sel withObject:(id)obj ;

@end
