//
//  NisusWindowController.h
//  NisusCore
//
//  Created by Martin on 2016.03.29.
//  Copyright (c) 2016 Nisus. All rights reserved.
//
// The normal NSWindowController suffers from one annoying problem:
//	* If the window/controller does not have a document or other owner, it is deallocated immediately after showing it.
//
// This general purpose replacement solves this problem and also allows easy caching.

#import <Cocoa/Cocoa.h>


@interface NisusWindowController : NSWindowController

+ (instancetype) windowControllerNisus ;
+ (NSArray*) visibleWindowControllersNisus ;

- (void) windowWillOpenNisus ;
- (void) windowWillCloseNisus ;

+ (BOOL) shouldUseNisusCache ;
- (void) willEnterNisusCache ;
- (void) willExitNisusCache ;

@end
