//
//  THInterprocessIdents.h
//  Thesaurus
//
//  Created by Martin on 2014.03.06.
//
//


/*** App ID for Nisus Thesaurus ***/
#define THNisusThesaurusApplicationBundleIdentifier (@"com.nisus.NisusThesaurus")






// This is the name of the connection via which Nisus Thesaurus vends <THDistributedThesaurus>
#define THDistributedThesaurusConnectionName (@"com.nisus.thesaurus.distributedThesaurusObject")


/*** Protocol Used by Distributed Object vended by Nisus Thesaurus App ***/
@protocol THDistributedThesaurus

- (oneway void) displayThesaurusWord:(NSString*)word ;
- (oneway void) displayThesaurusWord:(NSString*)word allowingReplacementViaConnectionWithName:(NSString*)callbackConnectionName ;

@end


/*** Protocol Used by Distributed Object vended by client app ***/
@protocol THDistributedThesaurusClient

- (oneway void) replaceThesaurusWord:(NSString*)originalWord withWord:(NSString*)newWord ;

@end







/*** These do not work under sandboxing because the notifications are never delivered ***/

// posted by the Nisus Thesaurus App/GUI when it is launched and ready to show words to the user
#define THDistributedNotification_AppIsReady (@"com.nisus.thesaurus.appIsReady")

// can be posted by any client that wants to show a word in the Nisus Thesaurus GUI
// object is the word to show
#define THDistributedNotification_ShowWord (@"com.nisus.thesaurus.showWord")

// posted by the Nisus Thesaurus App/GUI if the user would like to replace the last word sent via a "RequestShowWord" notification
// object is the replacement word
#define THDistributedNotification_ReplaceWord (@"com.nisus.thesaurus.replaceWord")


