//
//  THWindowController.h
//  Thesaurus
//
//  Created by Martin on Wed Sep 17 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.

#import <AppKit/AppKit.h>

#import <NisusThesaurus/THWordDisplayDelegate.h>
@class THWordLookup, THWordNetEntry, THLookupOption;
@class THGlossaryView, THBrowser;


@interface THWordWindowController : NSWindowController {
	THWordLookup* _wordLookup;
	id<THWordDisplayDelegate> _wordDisplayDelegate;
	
    CGFloat _colWidth;
    BOOL _isAllowReplace;
    
    // interface
    IBOutlet THBrowser* _browser;
    IBOutlet THGlossaryView* _glossView;
    IBOutlet NSSplitView* _splitView;
    IBOutlet NSComboBox* _wordInputField;
    IBOutlet NSButton* _lookupButton;
    IBOutlet NSButton* _replaceButton;
    
    // hold onto results so passive browser performance isn't awful
    NSMutableDictionary* _cachedCols;       // contains THBrowserLookupColumns
}

+ (NSArray*) wordWindowControllers ;

- (void) setDisplayedWord:(NSString*)word ;
@property (readonly) THWordLookup* wordLookup ;
@property (assign) id<THWordDisplayDelegate> wordDisplayDelegate ;

- (void) updateDisplay ;
- (void) setIsAllowReplace:(BOOL)isEn ;
- (NSString*) displayWord ;

// interface actions
- (IBAction) lookupWord:(id)sender ;
- (IBAction) replaceWord:(id)sender ;
- (void) copy:(id)sender ;

// broswer delegate methods & actions
- (NSString*) browser:(NSBrowser*)sender titleOfColumn:(NSInteger)col ;
- (NSInteger) browser:(NSBrowser*)sender numberOfRowsInColumn:(NSInteger)col ;
- (void) browser:(NSBrowser*)sender willDisplayCell:(id)cell atRow:(NSInteger)row column:(NSInteger)col ;
- (IBAction) browserSingleClick:(NSBrowser*)sender ;
- (IBAction) browserDoubleClick:(NSBrowser*)sender ;

- (void) splitView:(NSSplitView*)sender resizeSubviewsWithOldSize:(NSSize)oldSize ;

@end
